LogTo("/home/agustin/gap-4.10.1/bin/ufo/lift-br2a-M12-N4-t2-with_c2.log");

########################################################################################################################
#lifting, case t2 nonzero:
########################################################################################################################



LoadPackage("GBNP");

GBNP.ConfigPrint("y2","y1","c2","g2","g1","x2","x1");

t1:=Indeterminate(Rationals,"t1");;
t2:=Indeterminate(Rationals,"t2");;

#we need q12^4=1, so we just take q12=1,q,q^2,q^3

#q12=1

F:=Field(t1,t2);;
F1:=One(F);;


q:=E(4);;
z:=E(3);;
qz:=z*q^-1;;

q11:=z;;
q12:=1;;
q21:=(q12*q)^-1;;
q22:=q;;

#we add the variable c2 representing t2(1-g2^4)

y2:=[[[1]],[F1]];;
y1:=[[[2]],[F1]];;
c2:=[[[3]],[F1]];;
g2:=[[[4]],[F1]];;
g1:=[[[5]],[F1]];;
x2:=[[[6]],[F1]];;
x1:=[[[7]],[F1]];;


r1:=MulNP(y1,MulNP(y1,y1));;
gg1:=MulNP(g1,MulNP(g1,g1));;
s1:=MulNP(x1,MulNP(x1,x1));;

r2:=MulNP(y2,MulNP(y2,MulNP(y2,y2)));;
gg2:=MulNP(g2,MulNP(g2,MulNP(g2,g2)));;
r2d:=AddNP(r2,c2,F1,-F1);;
s2:=MulNP(x2,MulNP(x2,MulNP(x2,x2)));;
s2d:=AddNP(s2,[[[]],[F1]],F1,-t2);;

y12:=AddNP(MulNP(y1,y2),MulNP(y2,y1),F1,-q12);;
x12:=AddNP(MulNP(x1,x2),MulNP(x2,x1),F1,-q12);;
y112:=AddNP(MulNP(y1,y12),MulNP(y12,y1),F1,-q11*q12);;
x112:=AddNP(MulNP(x1,x12),MulNP(x12,x1),F1,-q11*q12);;

gy11:=AddNP(MulNP(g1,y1),MulNP(y1,g1),F1,-q11);;
gy12:=AddNP(MulNP(g1,y2),MulNP(y2,g1),F1,-q12);;
gy21:=AddNP(MulNP(g2,y1),MulNP(y1,g2),F1,-q21);;
gy22:=AddNP(MulNP(g2,y2),MulNP(y2,g2),F1,-q22);;

gx11:=AddNP(MulNP(g1,x1),MulNP(x1,g1),F1,-F1);;
gx12:=AddNP(MulNP(g1,x2),MulNP(x2,g1),F1,-F1);;
gx21:=AddNP(MulNP(g2,x1),MulNP(x1,g2),F1,-F1);;
gx22:=AddNP(MulNP(g2,x2),MulNP(x2,g2),F1,-F1);;

xy11:=AddNP(MulNP(x1,y1),MulNP(y1,x1),F1,-F1);;
xy12:=AddNP(MulNP(x1,y2),MulNP(y2,x1),F1,-F1);;
xy21:=AddNP(MulNP(x2,y1),MulNP(y1,x2),F1,-F1);;
xy22:=AddNP(MulNP(x2,y2),MulNP(y2,x2),F1,-F1);;

gg12:=AddNP(MulNP(g1,g2),MulNP(g2,g1),F1,-F1);;

y21:=AddNP(MulNP(y2,y1),MulNP(y1,y2),F1,-q21);;
x21:=AddNP(MulNP(x2,x1),MulNP(x1,x2),F1,-q21);;
y221:=AddNP(MulNP(y2,y21),MulNP(y21,y2),F1,-q22*q21);;
x221:=AddNP(MulNP(x2,x21),MulNP(x21,x2),F1,-q22*q21);;


y112:=AddNP(MulNP(y1,y12),MulNP(y12,y1),1,-q11*q12);
x112:=AddNP(MulNP(x1,x12),MulNP(x12,x1),1,-q11*q12);
g112:=MulNP(g1,MulNP(g1,g2));;


cy1:=AddNP(MulNP(c2,y1),MulNP(y1,c2),F1,-F1);;
cy2:=AddNP(MulNP(c2,y2),MulNP(y2,c2),F1,-F1);;
cg1:=AddNP(MulNP(c2,g1),MulNP(g1,c2),F1,-F1);;
cg2:=AddNP(MulNP(c2,g2),MulNP(g2,c2),F1,-F1);;
cx1:=AddNP(MulNP(c2,x1),MulNP(x1,c2),F1,-F1);;
cx2:=AddNP(MulNP(c2,x2),MulNP(x2,c2),F1,-F1);;


K:=[
r1,r2d,
s1,s2d,
y221,x221,
gy11,gy12,gy21,gy22,
gx11,gx12,gx21,gx22,
xy11,xy12,xy21,xy22,
gg12,
cy1,cy2,cg1,cg2,cx1,cx2
];;

G:=SGrobner(K);;

d1:=AddNP(y1,MulNP(g1,x1),1,1);;
d2:=AddNP(y2,MulNP(g2,x2),1,1);;

d12:=StrongNormalFormNP(AddNP(MulNP(d1,d2),MulNP(d2,d1),1,-q12),G);;
d112:=StrongNormalFormNP(AddNP(MulNP(d1,d12),MulNP(d12,d1),1,-q11*q12),G);


x112n:=function(n)
if n=1 then
return x112;
else return StrongNormalFormNP(MulNP(x112,x112n(n-1)),G);
fi;
end;;

y112n:=function(n)
if n=1 then
return y112;
else return StrongNormalFormNP(MulNP(y112,y112n(n-1)),G);
fi;
end;;

g112n:=function(n)
if n=1 then
return g112;
else return StrongNormalFormNP(MulNP(g112,g112n(n-1)),G);
fi;
end;;


d112n:=function(n)
if n=1 then
return d112;
else return StrongNormalFormNP(MulNP(d112,d112n(n-1)),G);
fi;
end;;

u:=StrongNormalFormNP(AddNP(y112n(12),MulNP(g112n(12),x112n(12)),F1,F1),G);;

r112:=StrongNormalFormNP(AddNP(d112n(12),u,F1,-F1),G);;

Print("\n y2^4=c2, x2^4=t2, q12=1. the difference is: \n");

PrintNP(r112);

###############################################################################

###############################################################################

#q12=q

F:=Field(t1,t2);;
F1:=One(F);;


q:=E(4);;
z:=E(3);;
qz:=z*q^-1;;

q11:=z;;
q12:=q;;
q21:=(q12*q)^-1;;
q22:=q;;

#we add the variable c2 representing t2(1-g2^4)

y2:=[[[1]],[F1]];;
y1:=[[[2]],[F1]];;
c2:=[[[3]],[F1]];;
g2:=[[[4]],[F1]];;
g1:=[[[5]],[F1]];;
x2:=[[[6]],[F1]];;
x1:=[[[7]],[F1]];;


r1:=MulNP(y1,MulNP(y1,y1));;
gg1:=MulNP(g1,MulNP(g1,g1));;
s1:=MulNP(x1,MulNP(x1,x1));;

r2:=MulNP(y2,MulNP(y2,MulNP(y2,y2)));;
gg2:=MulNP(g2,MulNP(g2,MulNP(g2,g2)));;
r2d:=AddNP(r2,c2,F1,-F1);;
s2:=MulNP(x2,MulNP(x2,MulNP(x2,x2)));;
s2d:=AddNP(s2,[[[]],[F1]],F1,-t2);;

y12:=AddNP(MulNP(y1,y2),MulNP(y2,y1),F1,-q12);;
x12:=AddNP(MulNP(x1,x2),MulNP(x2,x1),F1,-q12);;
y112:=AddNP(MulNP(y1,y12),MulNP(y12,y1),F1,-q11*q12);;
x112:=AddNP(MulNP(x1,x12),MulNP(x12,x1),F1,-q11*q12);;

gy11:=AddNP(MulNP(g1,y1),MulNP(y1,g1),F1,-q11);;
gy12:=AddNP(MulNP(g1,y2),MulNP(y2,g1),F1,-q12);;
gy21:=AddNP(MulNP(g2,y1),MulNP(y1,g2),F1,-q21);;
gy22:=AddNP(MulNP(g2,y2),MulNP(y2,g2),F1,-q22);;

gx11:=AddNP(MulNP(g1,x1),MulNP(x1,g1),F1,-F1);;
gx12:=AddNP(MulNP(g1,x2),MulNP(x2,g1),F1,-F1);;
gx21:=AddNP(MulNP(g2,x1),MulNP(x1,g2),F1,-F1);;
gx22:=AddNP(MulNP(g2,x2),MulNP(x2,g2),F1,-F1);;

xy11:=AddNP(MulNP(x1,y1),MulNP(y1,x1),F1,-F1);;
xy12:=AddNP(MulNP(x1,y2),MulNP(y2,x1),F1,-F1);;
xy21:=AddNP(MulNP(x2,y1),MulNP(y1,x2),F1,-F1);;
xy22:=AddNP(MulNP(x2,y2),MulNP(y2,x2),F1,-F1);;

gg12:=AddNP(MulNP(g1,g2),MulNP(g2,g1),F1,-F1);;

y21:=AddNP(MulNP(y2,y1),MulNP(y1,y2),F1,-q21);;
x21:=AddNP(MulNP(x2,x1),MulNP(x1,x2),F1,-q21);;
y221:=AddNP(MulNP(y2,y21),MulNP(y21,y2),F1,-q22*q21);;
x221:=AddNP(MulNP(x2,x21),MulNP(x21,x2),F1,-q22*q21);;


y112:=AddNP(MulNP(y1,y12),MulNP(y12,y1),1,-q11*q12);
x112:=AddNP(MulNP(x1,x12),MulNP(x12,x1),1,-q11*q12);
g112:=MulNP(g1,MulNP(g1,g2));;


cy1:=AddNP(MulNP(c2,y1),MulNP(y1,c2),F1,-F1);;
cy2:=AddNP(MulNP(c2,y2),MulNP(y2,c2),F1,-F1);;
cg1:=AddNP(MulNP(c2,g1),MulNP(g1,c2),F1,-F1);;
cg2:=AddNP(MulNP(c2,g2),MulNP(g2,c2),F1,-F1);;
cx1:=AddNP(MulNP(c2,x1),MulNP(x1,c2),F1,-F1);;
cx2:=AddNP(MulNP(c2,x2),MulNP(x2,c2),F1,-F1);;


K:=[
r1,r2d,
s1,s2d,
y221,x221,
gy11,gy12,gy21,gy22,
gx11,gx12,gx21,gx22,
xy11,xy12,xy21,xy22,
gg12,
cy1,cy2,cg1,cg2,cx1,cx2
];;

G:=SGrobner(K);;

d1:=AddNP(y1,MulNP(g1,x1),1,1);;
d2:=AddNP(y2,MulNP(g2,x2),1,1);;

d12:=StrongNormalFormNP(AddNP(MulNP(d1,d2),MulNP(d2,d1),1,-q12),G);;
d112:=StrongNormalFormNP(AddNP(MulNP(d1,d12),MulNP(d12,d1),1,-q11*q12),G);


x112n:=function(n)
if n=1 then
return x112;
else return StrongNormalFormNP(MulNP(x112,x112n(n-1)),G);
fi;
end;;

y112n:=function(n)
if n=1 then
return y112;
else return StrongNormalFormNP(MulNP(y112,y112n(n-1)),G);
fi;
end;;

g112n:=function(n)
if n=1 then
return g112;
else return StrongNormalFormNP(MulNP(g112,g112n(n-1)),G);
fi;
end;;


d112n:=function(n)
if n=1 then
return d112;
else return StrongNormalFormNP(MulNP(d112,d112n(n-1)),G);
fi;
end;;

u:=StrongNormalFormNP(AddNP(y112n(12),MulNP(g112n(12),x112n(12)),F1,F1),G);;

r112:=StrongNormalFormNP(AddNP(d112n(12),u,F1,-F1),G);;

Print("\n y2^4=c2, y2^4=t2, q12=q. the difference is: \n");

PrintNP(r112);

###############################################################################

###############################################################################


#q12=q^2

F:=Field(t1,t2);;
F1:=One(F);;


q:=E(4);;
z:=E(3);;
qz:=z*q^-1;;

q11:=z;;
q12:=q^2;;
q21:=(q12*q)^-1;;
q22:=q;;

#we add the variable c2 representing t2(1-g2^4)

y2:=[[[1]],[F1]];;
y1:=[[[2]],[F1]];;
c2:=[[[3]],[F1]];;
g2:=[[[4]],[F1]];;
g1:=[[[5]],[F1]];;
x2:=[[[6]],[F1]];;
x1:=[[[7]],[F1]];;


r1:=MulNP(y1,MulNP(y1,y1));;
gg1:=MulNP(g1,MulNP(g1,g1));;
s1:=MulNP(x1,MulNP(x1,x1));;

r2:=MulNP(y2,MulNP(y2,MulNP(y2,y2)));;
gg2:=MulNP(g2,MulNP(g2,MulNP(g2,g2)));;
r2d:=AddNP(r2,c2,F1,-F1);;
s2:=MulNP(x2,MulNP(x2,MulNP(x2,x2)));;
s2d:=AddNP(s2,[[[]],[F1]],F1,-t2);;

y12:=AddNP(MulNP(y1,y2),MulNP(y2,y1),F1,-q12);;
x12:=AddNP(MulNP(x1,x2),MulNP(x2,x1),F1,-q12);;
y112:=AddNP(MulNP(y1,y12),MulNP(y12,y1),F1,-q11*q12);;
x112:=AddNP(MulNP(x1,x12),MulNP(x12,x1),F1,-q11*q12);;

gy11:=AddNP(MulNP(g1,y1),MulNP(y1,g1),F1,-q11);;
gy12:=AddNP(MulNP(g1,y2),MulNP(y2,g1),F1,-q12);;
gy21:=AddNP(MulNP(g2,y1),MulNP(y1,g2),F1,-q21);;
gy22:=AddNP(MulNP(g2,y2),MulNP(y2,g2),F1,-q22);;

gx11:=AddNP(MulNP(g1,x1),MulNP(x1,g1),F1,-F1);;
gx12:=AddNP(MulNP(g1,x2),MulNP(x2,g1),F1,-F1);;
gx21:=AddNP(MulNP(g2,x1),MulNP(x1,g2),F1,-F1);;
gx22:=AddNP(MulNP(g2,x2),MulNP(x2,g2),F1,-F1);;

xy11:=AddNP(MulNP(x1,y1),MulNP(y1,x1),F1,-F1);;
xy12:=AddNP(MulNP(x1,y2),MulNP(y2,x1),F1,-F1);;
xy21:=AddNP(MulNP(x2,y1),MulNP(y1,x2),F1,-F1);;
xy22:=AddNP(MulNP(x2,y2),MulNP(y2,x2),F1,-F1);;

gg12:=AddNP(MulNP(g1,g2),MulNP(g2,g1),F1,-F1);;

y21:=AddNP(MulNP(y2,y1),MulNP(y1,y2),F1,-q21);;
x21:=AddNP(MulNP(x2,x1),MulNP(x1,x2),F1,-q21);;
y221:=AddNP(MulNP(y2,y21),MulNP(y21,y2),F1,-q22*q21);;
x221:=AddNP(MulNP(x2,x21),MulNP(x21,x2),F1,-q22*q21);;


y112:=AddNP(MulNP(y1,y12),MulNP(y12,y1),1,-q11*q12);
x112:=AddNP(MulNP(x1,x12),MulNP(x12,x1),1,-q11*q12);
g112:=MulNP(g1,MulNP(g1,g2));;


cy1:=AddNP(MulNP(c2,y1),MulNP(y1,c2),F1,-F1);;
cy2:=AddNP(MulNP(c2,y2),MulNP(y2,c2),F1,-F1);;
cg1:=AddNP(MulNP(c2,g1),MulNP(g1,c2),F1,-F1);;
cg2:=AddNP(MulNP(c2,g2),MulNP(g2,c2),F1,-F1);;
cx1:=AddNP(MulNP(c2,x1),MulNP(x1,c2),F1,-F1);;
cx2:=AddNP(MulNP(c2,x2),MulNP(x2,c2),F1,-F1);;


K:=[
r1,r2d,
s1,s2d,
y221,x221,
gy11,gy12,gy21,gy22,
gx11,gx12,gx21,gx22,
xy11,xy12,xy21,xy22,
gg12,
cy1,cy2,cg1,cg2,cx1,cx2
];;

G:=SGrobner(K);;

d1:=AddNP(y1,MulNP(g1,x1),1,1);;
d2:=AddNP(y2,MulNP(g2,x2),1,1);;

d12:=StrongNormalFormNP(AddNP(MulNP(d1,d2),MulNP(d2,d1),1,-q12),G);;
d112:=StrongNormalFormNP(AddNP(MulNP(d1,d12),MulNP(d12,d1),1,-q11*q12),G);


x112n:=function(n)
if n=1 then
return x112;
else return StrongNormalFormNP(MulNP(x112,x112n(n-1)),G);
fi;
end;;

y112n:=function(n)
if n=1 then
return y112;
else return StrongNormalFormNP(MulNP(y112,y112n(n-1)),G);
fi;
end;;

g112n:=function(n)
if n=1 then
return g112;
else return StrongNormalFormNP(MulNP(g112,g112n(n-1)),G);
fi;
end;;


d112n:=function(n)
if n=1 then
return d112;
else return StrongNormalFormNP(MulNP(d112,d112n(n-1)),G);
fi;
end;;

u:=StrongNormalFormNP(AddNP(y112n(12),MulNP(g112n(12),x112n(12)),F1,F1),G);;

r112:=StrongNormalFormNP(AddNP(d112n(12),u,F1,-F1),G);;

Print("\n y2^4=c2, y2^4=t2, q12=q^2. the difference is: \n");

PrintNP(r112);

###############################################################################

###############################################################################


#q12=q^3

F:=Field(t1,t2);;
F1:=One(F);;


q:=E(4);;
z:=E(3);;
qz:=z*q^-1;;

q11:=z;;
q12:=q^3;;
q21:=(q12*q)^-1;;
q22:=q;;

#we add the variable c2 representing t2(1-g2^4)

y2:=[[[1]],[F1]];;
y1:=[[[2]],[F1]];;
c2:=[[[3]],[F1]];;
g2:=[[[4]],[F1]];;
g1:=[[[5]],[F1]];;
x2:=[[[6]],[F1]];;
x1:=[[[7]],[F1]];;


r1:=MulNP(y1,MulNP(y1,y1));;
gg1:=MulNP(g1,MulNP(g1,g1));;
s1:=MulNP(x1,MulNP(x1,x1));;

r2:=MulNP(y2,MulNP(y2,MulNP(y2,y2)));;
gg2:=MulNP(g2,MulNP(g2,MulNP(g2,g2)));;
r2d:=AddNP(r2,c2,F1,-F1);;
s2:=MulNP(x2,MulNP(x2,MulNP(x2,x2)));;
s2d:=AddNP(s2,[[[]],[F1]],F1,-t2);;

y12:=AddNP(MulNP(y1,y2),MulNP(y2,y1),F1,-q12);;
x12:=AddNP(MulNP(x1,x2),MulNP(x2,x1),F1,-q12);;
y112:=AddNP(MulNP(y1,y12),MulNP(y12,y1),F1,-q11*q12);;
x112:=AddNP(MulNP(x1,x12),MulNP(x12,x1),F1,-q11*q12);;

gy11:=AddNP(MulNP(g1,y1),MulNP(y1,g1),F1,-q11);;
gy12:=AddNP(MulNP(g1,y2),MulNP(y2,g1),F1,-q12);;
gy21:=AddNP(MulNP(g2,y1),MulNP(y1,g2),F1,-q21);;
gy22:=AddNP(MulNP(g2,y2),MulNP(y2,g2),F1,-q22);;

gx11:=AddNP(MulNP(g1,x1),MulNP(x1,g1),F1,-F1);;
gx12:=AddNP(MulNP(g1,x2),MulNP(x2,g1),F1,-F1);;
gx21:=AddNP(MulNP(g2,x1),MulNP(x1,g2),F1,-F1);;
gx22:=AddNP(MulNP(g2,x2),MulNP(x2,g2),F1,-F1);;

xy11:=AddNP(MulNP(x1,y1),MulNP(y1,x1),F1,-F1);;
xy12:=AddNP(MulNP(x1,y2),MulNP(y2,x1),F1,-F1);;
xy21:=AddNP(MulNP(x2,y1),MulNP(y1,x2),F1,-F1);;
xy22:=AddNP(MulNP(x2,y2),MulNP(y2,x2),F1,-F1);;

gg12:=AddNP(MulNP(g1,g2),MulNP(g2,g1),F1,-F1);;

y21:=AddNP(MulNP(y2,y1),MulNP(y1,y2),F1,-q21);;
x21:=AddNP(MulNP(x2,x1),MulNP(x1,x2),F1,-q21);;
y221:=AddNP(MulNP(y2,y21),MulNP(y21,y2),F1,-q22*q21);;
x221:=AddNP(MulNP(x2,x21),MulNP(x21,x2),F1,-q22*q21);;


y112:=AddNP(MulNP(y1,y12),MulNP(y12,y1),1,-q11*q12);
x112:=AddNP(MulNP(x1,x12),MulNP(x12,x1),1,-q11*q12);
g112:=MulNP(g1,MulNP(g1,g2));;


cy1:=AddNP(MulNP(c2,y1),MulNP(y1,c2),F1,-F1);;
cy2:=AddNP(MulNP(c2,y2),MulNP(y2,c2),F1,-F1);;
cg1:=AddNP(MulNP(c2,g1),MulNP(g1,c2),F1,-F1);;
cg2:=AddNP(MulNP(c2,g2),MulNP(g2,c2),F1,-F1);;
cx1:=AddNP(MulNP(c2,x1),MulNP(x1,c2),F1,-F1);;
cx2:=AddNP(MulNP(c2,x2),MulNP(x2,c2),F1,-F1);;


K:=[
r1,r2d,
s1,s2d,
y221,x221,
gy11,gy12,gy21,gy22,
gx11,gx12,gx21,gx22,
xy11,xy12,xy21,xy22,
gg12,
cy1,cy2,cg1,cg2,cx1,cx2
];;

G:=SGrobner(K);;

d1:=AddNP(y1,MulNP(g1,x1),1,1);;
d2:=AddNP(y2,MulNP(g2,x2),1,1);;

d12:=StrongNormalFormNP(AddNP(MulNP(d1,d2),MulNP(d2,d1),1,-q12),G);;
d112:=StrongNormalFormNP(AddNP(MulNP(d1,d12),MulNP(d12,d1),1,-q11*q12),G);


x112n:=function(n)
if n=1 then
return x112;
else return StrongNormalFormNP(MulNP(x112,x112n(n-1)),G);
fi;
end;;

y112n:=function(n)
if n=1 then
return y112;
else return StrongNormalFormNP(MulNP(y112,y112n(n-1)),G);
fi;
end;;

g112n:=function(n)
if n=1 then
return g112;
else return StrongNormalFormNP(MulNP(g112,g112n(n-1)),G);
fi;
end;;


d112n:=function(n)
if n=1 then
return d112;
else return StrongNormalFormNP(MulNP(d112,d112n(n-1)),G);
fi;
end;;

u:=StrongNormalFormNP(AddNP(y112n(12),MulNP(g112n(12),x112n(12)),F1,F1),G);;

r112:=StrongNormalFormNP(AddNP(d112n(12),u,F1,-F1),G);;

Print("\n y2^4=c2, y2^4=t2, q12=q^3. the difference is: \n");

PrintNP(r112);

###############################################################################

###############################################################################
